local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap_hometown.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_hometown.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rocks_density.png", "ROCKS_DENSITY_MAP")

-- Register Custom Map Germany
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_GERMANY_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -2,
	--MinHeight = -18,
	MaxHeight = 95,
	--MaxHeight = 85,
	VillagePathList = {
		{
			Entrance = { 1020, 0, 323 },
			Exit = { 370, 0, 0 }
		},
		{
			Entrance = { 546, 0, 1020 },
			Exit = { 0, 0, 323 }
		},
		{
			Entrance = { 1020, 0, 786 },
			Exit = { 923, 0, 1020 }
		}
	},
	SpawnList = {
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 211, 28, 43 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 276, 12, 681 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 889, 20, 957 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 915, 20, 264 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		--Some more nodes to have a higher chance to get all available types of resources
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 372 , 20, 115 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 146 , 19, 459 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 624 , 16, 884 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 802, 19, 819 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 114 , 29, 132 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 498, 0, 560 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 466, 0, 504 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 485, 2, 429 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_RESOURCE_FISH",
			Position = { 711, 2, 831 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		}
	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few smaller Pine trees
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE", "PREFAB_TREE_OAK", "PREFAB_TREE_POPLAR" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						--Min = { 0.8, 0.8, 0.8, 1 },
						--Max = { 1, 1, 1, 1 }
						Min = { 0.4, 0.2, 0.0, 1 },
                        Max = { 0.9, 0.5, 0.0, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of Pine trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
		-- Create berries resources containers
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0,
					OffsetSizeRange = {
						Min = 1,
						Max = 1
					},
					OrientationRange = {
						Min = { 0.0, -180, 0.0},
						Max = { 0.0, 180, 0.0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
		-- Create rocks resources containers
			DensityMap = "ROCKS_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0,
					OffsetSizeRange = {
						Min = 1,
						Max = 1
					},
					OrientationRange = {
						Min = { 0.0, -180, 0.0},
						Max = { 0.0, 180, 0.0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})